<script lang="typescript">
  import { onMount } from "svelte";

  export let imageFile: any = {};

  let readimg: any;

  onMount(() => {});

  function readImage() {
    let fileToLoad = readimg.files[0];

    const fileReader = new FileReader();
    fileReader.onload = async function (fileLoadedEvent: any) {
      const textFromFileLoaded = fileLoadedEvent.target.result;

      imageFile = {
        name: fileToLoad["name"],
        src: await convertResolution(textFromFileLoaded),
      };
      console.log("imageFile", imageFile);
    };
    fileReader.readAsDataURL(fileToLoad);
    readimg.value = "";
  }

  function convertResolution(base64: string) {
    return new Promise((resolve, reject) => {
      let canvas = document.createElement("canvas");
      let img = new Image();
      img.onload = function () {
        let iw = img.width;
        let ih = img.height;
        let scale = Math.min(500 / iw, 500 / ih);
        let iwScaled = iw * scale;
        let ihScaled = ih * scale;
        canvas.width = iwScaled;
        canvas.height = ihScaled;
        let ctx: any = canvas.getContext("2d");
        ctx.drawImage(img, 0, 0, iwScaled, ihScaled);
        resolve(canvas.toDataURL());
      };
      img.src = base64;
    });
  }
</script>

<div class="flex w-full justify-center bg-grey-lighter">
  <label class="">
    {#if imageFile && Object.entries(imageFile).length}
      <img
        class="cursor-pointer h-32 w-32 rounded-full border border-gray-200 shadow"
        src={imageFile["src"]}
      />
    {:else}
      <div class="cursor-pointer h-32 w-32 flex justify-center items-center rounded-full border border-gray-200 shadow">
        <svg
          class="w-8 h-8 cursor-pointer"
          fill="currentColor"
          xmlns="http://www.w3.org/2000/svg"
          viewBox="0 0 20 20"
        >
          <path
            d="M16.88 9.1A4 4 0 0 1 16 17H5a5 5 0 0 1-1-9.9V7a3 3 0 0 1
            4.52-2.59A4.98 4.98 0 0 1 17 8c0 .38-.04.74-.12 1.1zM11 11h3l-4-4-4
            4h3v3h2v-3z"
          />
        </svg>
      </div>
    {/if}

    <input
      class="hidden"
      on:change={readImage}
      bind:this={readimg}
      type="file"
      accept="image/*"
      name="image"
    />
  </label>
</div>
